searchNodes=[{"doc":"Documentation for Borsh .","ref":"Borsh.html","title":"Borsh","type":"module"},{"doc":"Decodes binary data into Elixir struct. Returns tuple with a struct and the rest of bytes.","ref":"Borsh.html#decode/2","title":"Borsh.decode/2","type":"function"},{"doc":"Encodes Elixir struct into binary data.","ref":"Borsh.html#encode/1","title":"Borsh.encode/1","type":"function"},{"doc":"Decodes binary data into Elixir struct.","ref":"Borsh.Decoder.html","title":"Borsh.Decoder","type":"module"},{"doc":"","ref":"Borsh.Decoder.html#decode_struct/2","title":"Borsh.Decoder.decode_struct/2","type":"function"},{"doc":"","ref":"Borsh.Decoder.html#read_value/2","title":"Borsh.Decoder.read_value/2","type":"function"},{"doc":"Encodes Elixir data structures into binary data.","ref":"Borsh.Encoder.html","title":"Borsh.Encoder","type":"module"},{"doc":"","ref":"Borsh.Encoder.html#encode_field/2","title":"Borsh.Encoder.encode_field/2","type":"function"},{"doc":"","ref":"Borsh.Encoder.html#encode_struct/1","title":"Borsh.Encoder.encode_struct/1","type":"function"},{"doc":"Borsh is a binary serializer for security-critical projects. borsh_serializer supports base58-encoded binary fields (Solana public keys as strings).","ref":"readme.html","title":"Borsh binary serializer","type":"extras"},{"doc":"This library requires Elixir 1.11 or above. Add borsh_serializer to your list of dependencies in mix.exs : def deps do [ { :borsh_serializer , &quot;~&gt; 1.0&quot; } ] end","ref":"readme.html#installation","title":"Borsh binary serializer - Installation","type":"extras"},{"doc":"# Define struct and its borsh schema: defmodule Person do @moduledoc false defstruct id : 0 , name : nil , email : nil def borsh_schema do [ { :id , :u16 } , { :name , :string } , { :wallet , { :base58 , 32 } } ] end end person = % Person { id : 123 , name : &quot;John&quot; , wallet : &quot;Hj1bMz4GZyRANWxBEzm6hh29Mk54f9YMh8mBiWy1PUXE&quot; } # Encode into binary bindata = Borsh . encode ( person ) # Decode from binary { person , &quot;&quot; } = Borsh . decode ( bindata , Person ) For a complex example, take a look at Metaplex Metadata schema I used for tests.","ref":"readme.html#usage","title":"Borsh binary serializer - Usage","type":"extras"},{"doc":"To define a schema, you must implement borsh_schema/0 method, which returns a list of field definitions. Each field definition is a tuple {:field_name, :field_type} . Supported data types with examples: # Unsigned integers :u8 , :u16 , :u32 , :u64 , :u128 # Examples: { :age , :u8 } { :counter , :u128 } # Signed integers :i8 , :i16 , :i32 , :i64 , :i128 # Example: { :amount , :i32 } # Float numbers :f32 , :f64 # Example: { :temp , :f32 } # String type: :string # Example: { :username , :string } # Enum values are encoded as u8 and are zero-indexed { :enum , values } # Example: { :color , { :enum , [ &quot;red&quot; , &quot;green&quot; , &quot;blue&quot; ] } } # Fixed size array { :array , item_type , array_size } # Example: { :numbers , { :array , :u32 , 5 } } # Dynamic size array { :array , :item_type } # Example: { :tags , { :array , :string } } # Optional fields { :option , field_definition } # Examples: { :username , { :option , :string } } { :tags , { :option , { :array , :string } } } # Embedded Structs { :struct , module } # Examples: { :user , { :struct , MyUserStructModule } } # Binary Data { :binary , byte_size } , { :base64 , byte_size } , { :base58 , byte_size } # Examples: { :rawdata , { :binary , 256 } } { :pubkey , { :base58 , 32 } }","ref":"readme.html#data-types","title":"Borsh binary serializer - Data Types","type":"extras"}]